import { Query } from '../../../../query/domain';
import { Connection } from '../../../../connection/application';
import { DialectService } from '../../../../language/application';
import { QueryOptions, MappingConfigService, Data } from 'lambdaorm-base';
import { Expressions } from '3xpr';
import { QueryInternalExecutor } from './queryInternalExecutor';
export declare class QueryBulkInsertExecutor {
    options: QueryOptions;
    private solveDefaults;
    private solveWriteValues;
    private constraints;
    private executor;
    constructor(executor: QueryInternalExecutor, expressions: Expressions, options: QueryOptions);
    bulkInsert(query: Query, data: Data, mapping: MappingConfigService, dialect: DialectService, connection: Connection): Promise<any[]>;
    private bulkInsertIncludesBefore;
    private bulkInsertIncludeBeforeOneToMany;
    private bulkInsertIncludeBeforeOneToOne;
    private bulkInsertIncludesAfter;
    private bulkInsertIncludeAfterManyToOne;
    private bulkInsertIncludeAfterOneToOne;
    private _chunkInsert;
}
