import { Mapping, SchemaFacade } from 'lambdaorm-base';
import { Query } from '../../../query/domain';
import { Helper } from '../../../shared/application';
import { LanguagesService } from './languagesService';
export declare class DDLBuilderService {
    private readonly schemaFacade;
    private readonly languages;
    readonly stage: string;
    private readonly helper;
    private domain;
    constructor(schemaFacade: SchemaFacade, languages: LanguagesService, stage: string, helper: Helper);
    drop(mappings: Mapping[]): Query[];
    truncate(mappings: Mapping[]): Query[];
    sync(mappings: Mapping[]): Query[];
    private _sync;
    private _drop;
    private _dropRelations;
    private _dropRelation;
    private _dropEntity;
    private _dropIndexes;
    private _truncate;
    private _syncRemoveForEntitiesChanges;
    private _syncRemovePrimaryKey;
    private _syncRemoveUniqueKey;
    private _syncRemoveIndexForChanges;
    private _syncRemoveFkForChanges;
    private _syncRemoveForRemovedEntities;
    private _syncCreateEntities;
    private _syncCreateForEntitiesChanges;
    private _syncAddPropertyForEntitiesChanges;
    private _syncModifyPropertyForEntitiesChanges;
    private _syncRemovePropertyForEntityChanges;
    private _syncCreatePkForChangesInEntity;
    private _syncCreateUkForChangesInEntity;
    private _syncCreateIndexesForChangesInEntity;
    private _syncCreateFksForChangesInEntity;
    private _syncCreateSequencesForChangesInEntity;
    private _syncCreateForNewEntities;
    private _syncCreateFksForNewEntity;
    private _syncCreateIndexesForNewEntity;
    private evalDataSource;
    private builder;
    private addQuery;
    private changeRelation;
}
